import Vue from 'vue'
import Button from './button'
import Icon from './icon'
import ButtonGroup from "./button-group"

// 注意这个写法 Button是单文件组件的形式 这里直接引入并注册即可
Vue.component('g-button', Button)
Vue.component('g-icon', Icon)
Vue.component('g-button-group', ButtonGroup)






new Vue({
    el: '#app',
    data: {
        rootLoadingState: false,
        loading2: true,
        loading3: false
    }
})



// unit test
import chai from 'chai'
import spies from 'chai-spies'
chai.use(spies)
const expect = chai.expect
try {



    {
        // Button是一个对象,而且是一个配置不完全的对象，之所以说它配置不完全，是因为它似乎还没有Vue的所有属性，比如生命周期这些还没完全写好，当然这些是我自己想的
        // console.log(Button) 
        // {
        // beforeCreate: [ƒ]
        // beforeDestroy: [ƒ]
        // functional: undefined
        // methods: {onClick: ƒ}
        // name: "g-button"
        // props: {icon: {…}, iconPosition: {…}, loading: {…}}
        // render: ƒ ()
        // staticRenderFns: []
        // _Ctor: {0: ƒ}
        // _compiled: true
        // _scopeId: null
        // __proto__: Object
        // }



        const Constructor = Vue.extend(Button)
        // 与上面的相对比，Button本来是个对象，但是经过Vue.extend这一方法之后，生成了Constructor这一构造函数，注意这是一个函数！

        // console.log(Constructor)
        //
        // ƒ VueComponent (options) {
        // this._init(options);
        //   }

        // 然后根据这个函数构造，生成真正的Vue实例
        // 这个和react小书里面写的东西好像！
        const button = new Constructor({
            propsData: {
                icon: 'setting'
            }
        })
        button.$mount('#test')
        let useElement = button.$el.querySelector('use')
        expect(useElement.getAttribute('xlink:href')).to.eq('#i-setting')

        // console.log(button)
        //     {
        //          $attrs: Object
        //          $children: []
        //          $createElement: ƒ (a, b, c, d)
        //          $listeners: Object
        //          $options: {components: {…}, directives: {…}, filters: {…}, _base: ƒ, props: {…}, …}
        //          $parent: undefined
        //          $refs: {}
        //          $root: VueComponent {_uid: 14, _isVue: true, $options: {…}, _renderProxy: Proxy, _self: VueComponent, …}
        //          $scopedSlots: {}
        //          $slots: {}
        //          $vnode: undefined
        //          icon: undefined
        //          iconPosition: "left"
        //          loading: false
        //          onClick: ƒ ()
        //          _c: ƒ (a, b, c, d)
        //          _data: {__ob__: Observer}
        //          _directInactive: false
        //          _events: {}
        //          _hasHookEvent: false
        //          _inactive: null
        //          _isBeingDestroyed: false
        //          _isDestroyed: false
        //          _isMounted: false
        //          _isVue: true
        //          _props: {}
        //          _renderProxy: Proxy {_uid: 14, _isVue: true, $options: {…}, _renderProxy: Proxy, _self: VueComponent, …}
        //          _self: VueComponent {_uid: 14, _isVue: true, $options: {…}, _renderProxy: Proxy, _self: VueComponent, …}
        //          _staticTrees: null
        //          _uid: 14
        //          _vnode: null
        //          _watcher: null
        //          _watchers: []
        //          $data: Object
        //          $isServer: false
        //          $props: Object
        //          $ssrContext: undefined
        //          get $attrs: ƒ reactiveGetter()
        //          set $attrs: ƒ reactiveSetter(newVal)
        //          get $listeners: ƒ reactiveGetter()
        //          set $listeners: ƒ reactiveSetter(newVal)
        //          __proto__: Vue
        //      }






    } {
        const Constructor = Vue.extend(Button)
        const vm = new Constructor({
            propsData: {
                icon: 'setting',
                loading: true
            }
        })
        vm.$mount()
        let useElement = vm.$el.querySelector('use')
        let href = useElement.getAttribute('xlink:href')
        expect(href).to.eq('#i-loading')
    } {
        const div = document.createElement('div')
        document.body.appendChild(div)
        const Constructor = Vue.extend(Button)
        const button = new Constructor({
            propsData: {
                icon: 'setting'
            }
        })
        // 这里就必须挂载到页面上了 因为如果不挂载到页面上 那就没有渲染 就取不到css的值
        button.$mount(div)
        let svg = button.$el.querySelector('svg')
        let {
            order
        } = window.getComputedStyle(svg)
        expect(order).to.eq("1")
    } {
        const div = document.createElement('div')
        document.body.appendChild(div)
        const Constructor = Vue.extend(Button)
        const button = new Constructor({
            propsData: {
                icon: 'setting',
                iconPosition: 'right'
            }
        })
        button.$mount(div)
        let svg = button.$el.querySelector('svg')
        let {
            order
        } = window.getComputedStyle(svg)
        expect(order).to.eq("2")

        // 
        button.$el.remove()
        button.$destroy()

    } {
        // mock
        const Constructor = Vue.extend(Button)
        const vm = new Constructor({
            propsData: {
                icon: 'setting',
                iconPosition: 'right'
            }
        })
        vm.$mount()
        let spy = chai.spy(function() {})
        //注意此时在组件上绑定事件的写法
        vm.$on('click', spy)
        let button = vm.$el
        button.click()
        expect(spy).to.have.been.called()
        // let {order} = window.getComputedStyle(svg)
        // expect(order).to.eq("2")

        // 
    }
} catch (error) {
    window.errors = [error]
} finally {
   window.errors && window.errors.map((error)=>{
        console.log(error.message)
    })
}