// 打包js和css 打开屋头浏览器 运行测试用例 关闭浏览器 把测试结果打印到终端

// 有时候需要运行 rm -rf .cache dist ,但是在script的test脚本中加入--no-cache之后就不用运行这个了


const expect = chai.expect;
// 为什么需要打包以及打包流程
// 打包原因 浏览器不认识import关键字
// 打包流程 引入Vue源代码
// 把Vue做成一个变量 暴露出来
import Vue from 'vue'
import Button from '../src/button'

Vue.config.productionTip = false
Vue.config.devtools = false

describe('Button', () => {
    // 每个it是独立的测试用例 用来隔绝不同的代码
    // 前面是测试用例的名字 匿名函数里面才是测试的具体代码
    it('存在.', () => {
        // expect(Button).to.be.ok
        expect(Button).to.exist
        // expect(1).to.equal(3)
        // 不相关的知识点deep
        // expect([1,2]).to.deep.eq([1,2]) 通过 加了deep，检测数组里面的内容
        // expect([1,2]).to.eq([1,2]) 不通过 没加deep 检查内存地址 发现不同

    })
    it('可以设置icon.', () => {
        const Constructor = Vue.extend(Button)
        const vm = new Constructor({
        propsData: {
            icon: 'settings'
        }
        }).$mount()
        const useElement = vm.$el.querySelector('use')
        expect(useElement.getAttribute('xlink:href')).to.equal('#i-settings')
        vm.$destroy()
    })
    it('可以设置loading.', () => {
        const Constructor = Vue.extend(Button)
        const vm = new Constructor({
        propsData: {
            icon: 'settings',
            loading: true
        }
        }).$mount()
        const useElements = vm.$el.querySelectorAll('use')
        expect(useElements.length).to.equal(1)
        expect(useElements[0].getAttribute('xlink:href')).to.equal('#i-loading')
        vm.$destroy()
    })
    it('icon 默认的 order 是 1', () => {
        const div = document.createElement('div')
        document.body.appendChild(div)
        const Constructor = Vue.extend(Button)
        const vm = new Constructor({
        propsData: {
            icon: 'settings',
        }
        }).$mount(div)
        const icon = vm.$el.querySelector('svg')
        expect(getComputedStyle(icon).order).to.eq('1')
        vm.$el.remove()
        vm.$destroy()
    })
    it('设置 iconPosition 可以改变 order', () => {
        const div = document.createElement('div')
        document.body.appendChild(div)
        const Constructor = Vue.extend(Button)
        const vm = new Constructor({
        propsData: {
            icon: 'settings',
            iconPosition: 'right'
        }
        }).$mount(div)
        const icon = vm.$el.querySelector('svg')
        expect(getComputedStyle(icon).order).to.eq('2')
        vm.$el.remove()
        vm.$destroy()
    })
    it('点击 button 触发 click 事件', () => {
        const Constructor = Vue.extend(Button)
        const vm = new Constructor({
        propsData: {
            icon: 'settings',
        }
        }).$mount()

        const callback = sinon.fake();
        //为什么不写成下面这样的形式呢？因为无法检测函数是否被调用了，所以就引用了别人的库
        // const callback = function(){}
        vm.$on('click', callback)
        vm.$el.click()
        expect(callback).to.have.been.called

    })
})